﻿using System;
using System.Windows.Controls;
using System.Windows.Media;

namespace UmlDiagramDesigner.Controls
{
    public class CartesianCanvas : Canvas
    {
        public CartesianCanvas()
        {
            this.SizeChanged +=
                (sender, args) =>
                    this.SetCoordinateSystem(-this.ActualWidth/2,
                                             this.ActualWidth/2,
                                             -this.ActualHeight/2,
                                             this.ActualHeight/2);
        }

        public Canvas SetCoordinateSystem(Double xMin, Double xMax, Double yMin, Double yMax)
        {
            var width = xMax - xMin;
            var height = yMax - yMin;

            var translateX = -xMin;
            var translateY = height + yMin;

            var group = new TransformGroup();

            group.Children.Add(new TranslateTransform(translateX, -translateY));
            group.Children.Add(new ScaleTransform(ActualWidth / width, ActualHeight / -height));

            RenderTransform = group;

            return this;
        }
    }
}
