﻿using System;
using System.Collections.Generic;
using UmlDiagramDesigner.Core;
using UmlDiagramDesigner.DTO;
using UmlDiagramDesigner.Services;
using UmlDiagramDesigner.ViewModels;

namespace UmlDiagramDesigner.DAL.Database
{
    public class DiagramPersistanceFacade
    {
        private readonly DiagramRepository _repository = new DiagramRepository();
        private readonly IDialogService _dialogService = new WpfDialogService();

        public bool Save(CanvasViewModel item)
        {
            try
            {
                return _repository.Save(item);
            }
            catch (Exception ex)
            {
                _dialogService.Display(ex);
                return false;
            }
        }

        public CanvasViewModel Load(string id)
        {
            try
            {
                return _repository.Load(id);
            }
            catch (Exception ex)
            {
                _dialogService.Display(ex);
                return null;
            }
        }

        public bool Delete(string id)
        {
            try
            {
                return _repository.Delete(id);
            }
            catch (Exception ex)
            {
                _dialogService.Display(ex);
                return false;
            }
        }

        public List<CanvasViewModel> GetAll()
        {
            try
            {
                return _repository.GetAll();
            }
            catch (Exception ex)
            {
                _dialogService.Display(ex);
                return null;
            }
        }

        public List<DiagramNameAndItemCountDTO> GetAllAvailable()
        {
            try
            {
                return _repository.GetAllAvailable();
            }
            catch (Exception ex)
            {
                _dialogService.Display(ex);
                return null;
            }
        }
    }
}
