﻿using System.Windows;
using Microsoft.Win32;
using UmlDiagramDesigner.Core;
using UmlDiagramDesigner.Services;
using UmlDiagramDesigner.ViewModels;

namespace UmlDiagramDesigner.DAL.Export
{
    public abstract class ExporterBase :IExporter
    {
        protected SaveFileDialog SaveFileDialog;

        protected ExporterBase()
        {
            DialogService = new WpfDialogService();
        }

        public IDialogService DialogService { get; set; }

        protected abstract string FileFilter { get;}

        protected string GetFilePath()
        {
            SaveFileDialog = new SaveFileDialog() {Filter = FileFilter, AddExtension = true};

            var result = SaveFileDialog.ShowDialog();

            if (result.HasValue && result == true)
                return SaveFileDialog.FileName;
            return null;
        }


        public abstract void Export(CanvasViewModel diagram);
        public FrameworkElement Canvas { get; set; }
    }
}
