﻿using System.ComponentModel;
using System.Runtime.CompilerServices;
using UmlDiagramDesigner.Annotations;

namespace UmlDiagramDesigner.DTO
{
    public abstract class PropertyChangedDTO : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        [NotifyPropertyChangedInvocator]
        protected virtual void OnPropertyChanged([NotNull,CallerMemberName] string propertyName = null)
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if (handler != null) handler(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
