﻿using System;
using System.Globalization;
using System.Windows.Data;
using System.Windows.Media;
using UmlDiagramDesigner.ViewModels.DependentElements;

namespace UmlDiagramDesigner.Helpers.Convertors
{
    public class PrimaryKeyToIconColorConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            var attribute = value as AttributeViewModel;
            if (attribute == null)
            {
                return new SolidColorBrush(Colors.Black);
            }

            if (attribute.IsPrimaryKey)
                return new SolidColorBrush(Colors.Gold);
            if(attribute.IsForeignKey)
                return new SolidColorBrush(Colors.DimGray);
            return new SolidColorBrush(Colors.Black);
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
}
