﻿using System;
using UmlDiagramDesigner.Annotations;
using UmlDiagramDesigner.Core.Enums;

namespace UmlDiagramDesigner.Models.Attributes
{
    /// <summary>
    /// Attribute which specifies, that a certain class requires certain <c>SqlConstraint</c> to work properly.
    /// </summary>
    [AttributeUsage(AttributeTargets.Class, AllowMultiple = false, Inherited = false)]
    public class RequiresConstraintAttribute : Attribute
    {
        public RequiresConstraintAttribute([NotNull] SqlConstraint constraint)
        {
            Constraint = constraint;
        }

        public SqlConstraint Constraint { get; private set; }
    }
}
