﻿using System.Windows.Data;
using UmlDiagramDesigner.Properties;

namespace UmlDiagramDesigner.Models
{
    /// <summary>
    /// Provides a way to easily bind application default settings in XAML.
    /// This class is not responsible for saving, just save the default app settings manually.
    /// </summary>
    public class BindableSettings : Binding
    {
        public BindableSettings()
        {
            Initialize();
        }

        public BindableSettings(string path)
            :base(path)
        {
            Initialize();
        }

        private void Initialize()
        {
            //set the settings to use the default app settings
            this.Source = Settings.Default;
            //mode is TwoWay, so user can modify it via binding
            this.Mode = BindingMode.TwoWay;
        }
    }
}
