﻿using System.Globalization;
using System.Text.RegularExpressions;
using System.Windows.Controls;
using VR = System.Windows.Controls.ValidationResult;
namespace UmlDiagramDesigner.Models.DiagramValidation
{
    public class EntityNameValidationRule : ValidationRule
    {
        public override VR Validate(object value, CultureInfo cultureInfo)
        {
            var strValue = (value ?? string.Empty).ToString();

            if(string.IsNullOrEmpty(strValue))
                return new VR(false, "Value cannot be empty.");

            if (!Regex.IsMatch(strValue, @"^[a-zA-Z0-9_]+$"))
            {
                return new VR(false, "Value cannot contain special characters or whitespaces.");
            }

            return new VR(true, null);
        }
    }
}
