﻿using System;
using System.Windows.Input;

namespace UmlDiagramDesigner.ViewModels.Commands
{
    public class GenericCommand<T> : ICommand
    {
        private readonly Action<T> _action;
        private readonly bool _canExecute;

        public GenericCommand(Action<T> action, bool canExecute = true)
        {
            _action = action;
            _canExecute = canExecute;
        }

        public bool CanExecute(object parameter)
        {   //zde lze implementovat libovolnou logiku pro vyhodnocení, zda
            //se má Command spustit
            return _canExecute;
        }

        public void Execute(object parameter)
        {
                _action((T) parameter);
        }

        private void RaiseCanExecuteChangedEvent()
        {
            if (CanExecuteChanged != null)
                CanExecuteChanged(this, new EventArgs());
        }

        public event EventHandler CanExecuteChanged;
    }
}
