﻿using System.Collections.Generic;
using UmlDiagramDesigner.CodeGeneration.Enums;
using UmlDiagramDesigner.Data;

namespace UmlDiagramDesigner.CodeGeneration.Contracts
{
	/// <summary>
	/// Language properties for all OOP languages.
	/// </summary>
	public interface IOopLanguageProperties : ILanguageProperties
    {
		/// <summary>
		/// Gets the accessibilities dictionary.
		/// </summary>
		/// <value>
		/// The accessibilities.
		/// </value>
		Dictionary<Accessibility, string> Accessibilities { get; }
		/// <summary>
		/// Generates the string for <param name="navigationProperty"></param>.
		/// Usually it means a creating some sort of property with getter and setter.
		/// </summary>
		/// <param name="navigationProperty">The navigation property.</param>
		/// <returns></returns>
		string GenerateNavPropertyDataType(ForeignKeyConstraint navigationProperty);
    }
}
