﻿using System.Collections.Generic;
using Microsoft.SqlServer.Server;
using UmlDiagramDesigner.Core.Enums;
using UmlDiagramDesigner.Data;

namespace UmlDiagramDesigner.CodeGeneration.Contracts
{
	/// <summary>
	/// SQL language properties
	/// </summary>
	public interface ISqlProperties : ILanguageProperties
    {
		/// <summary>
		/// Gets the keywords of SQL environment (for example MySQL environment).
		/// </summary>
		/// <value>
		/// The keywords.
		/// </value>
		HashSet<string> Keywords { get; }
		/// <summary>
		/// Gets the trigger events dictionary.
		/// </summary>
		/// <value>
		/// The trigger events.
		/// </value>
		Dictionary<TriggerEvent, string> TriggerEvents { get; }
		/// <summary>
		/// Gets the string for provided constraint.
		/// </summary>
		/// <typeparam name="TConstraint">The type of the constraint.</typeparam>
		/// <returns></returns>
		string Constraints<TConstraint>() where TConstraint : Constraint;
    }
}
