﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using UmlDiagramDesigner.Core.Enums;

namespace UmlDiagramDesigner.Data
{
	/// <summary>
	/// Data modeling attribute.
	/// </summary>
	public class DataAttribute 
    {
		/// <summary>
		/// Gets or sets the name.
		/// </summary>
		/// <value>
		/// The name.
		/// </value>
		public string Name { get; set; }
		/// <summary>
		/// Gets or sets the type of the data.
		/// </summary>
		/// <value>
		/// The type of the data.
		/// </value>
		public DbDataType DataType { get; set; }
		/// <summary>
		/// Gets or sets <see cref="Class"/> that this attribute is part of.
		/// </summary>
		/// <value>
		/// The part of.
		/// </value>
		public Class PartOf { get; set; }
		/// <summary>
		/// Gets or sets the constraints.
		/// </summary>
		/// <value>
		/// The constraints.
		/// </value>
		public HashSet<Constraint> Constraints { get; set; }
    }
}
