﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using UmlDiagramDesigner.Core.Graph;
using UmlDiagramDesigner.ViewModels.DiagramRelationships;

namespace UmlDiagramDesigner.Test.Mocks
{
    public class IndexedVertexMock : IIndexedVertex
    {
        public IndexedVertexMock()
        {
            Neighbours = new Collection<Tuple<IIndexedVertex, RelationshipViewModelBase>>();
        }

        public string Name { get; set; }
        public int Index { get; set; }
        public int LowLink { get; set; }
        public ICollection<Tuple<IIndexedVertex,RelationshipViewModelBase>> Neighbours { get; set; }

        public IEnumerable<IVertex> GetNeighbours(bool revert = false)
        {
            return Neighbours.Select(n => n.Item1);
        }

        public IEnumerable<IVertex> GetNeighbours<T>(bool revert = false) where T : class 
        {
            return Neighbours.Where(n => n.Item2 is T).Select(n => n.Item1);
        }

        public IEnumerable<IIndexedVertex> GetIndexedNeighbours(bool revert = false)
        {
            return Neighbours.Select(n => n.Item1);
        }

        public IEnumerable<IIndexedVertex> GetIndexedNeighbours<T>(bool revert = false) where T : class 
        {
            var result =  Neighbours.Where(n => n.Item2 is T).Select(n => n.Item1).ToArray();
            return result;
        }
    }
}
